library Screenresize;

import 'dart:ui';

class Screens {
  static Screens _instance;
  static const int defaultWidth = 1080;
  static const int defaultHeight = 1920;
  
  num uiWidthPx;
  num uiHeightPx;
  
  bool allowFontScaling;
  
  static double _ScreensWidth;
  static double _ScreensHeight;
  static double _pixelRatio;
  static double _statusBarHeight;
  static double _bottomBarHeight;
  static double _textScaleFactor;
  
  Screens._();
  
  factory Screens() {
    return _instance;
  }
  
  static void i(
      {num width = defaultWidth,
        num height = defaultHeight,
        bool allowFontScaling = false}) {
    if (_instance == null) {
      _instance = Screens._();
    }
    _instance.uiWidthPx = width;
    _instance.uiHeightPx = height;
    _instance.allowFontScaling = allowFontScaling;
    _pixelRatio = window.devicePixelRatio;
    _ScreensWidth = window.physicalSize.width;
    _ScreensHeight = window.physicalSize.height;
    _statusBarHeight = window.padding.top;
    _bottomBarHeight = window.padding.bottom;
    _textScaleFactor = window.textScaleFactor;
  }
  
  static double get textScaleFactor => _textScaleFactor;
  static double get pixelRatio => _pixelRatio;
  static double get ScreensWidth => _ScreensWidth / _pixelRatio;
  static double get ScreensHeight => _ScreensHeight / _pixelRatio;
  static double get ScreensWidthPx => _ScreensWidth;
  static double get ScreensHeightPx => _ScreensHeight;
  static double get statusBarHeight => _statusBarHeight / _pixelRatio;
  static double get statusBarHeightPx => _statusBarHeight;
  static double get bottomBarHeight => _bottomBarHeight;
  double get scaleWidth => ScreensWidth / uiWidthPx;
  double get scaleHeight => ScreensHeight / uiHeightPx;
  double get scaleText => scaleWidth;
  
  num setWidth(num width) => width * scaleWidth;
  
  num setHeight(num height) => height * scaleHeight;
  
  ///@param [allowFontScaling]
  num Size(num fontSize, {bool allowFontScalingSelf}) =>
      allowFontScalingSelf == null
      ? (allowFontScaling
         ? (fontSize * scaleText)
         : ((fontSize * scaleText) / _textScaleFactor))
      : (allowFontScalingSelf
         ? (fontSize * scaleText)
         : ((fontSize * scaleText) / _textScaleFactor));
}

extension SizeExtension on num {
 
  num get w => Screens().setWidth(this);
  num get h => Screens().setHeight(this);
  num get sp => Screens().Size(this);
  num get ssp => Screens().Size(this, allowFontScalingSelf: true);
  num get nsp => Screens().Size(this, allowFontScalingSelf: false);
  
  num get wp => Screens.ScreensWidth * this;
  num get hp => Screens.ScreensHeight * this;
}
